"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const location_1 = require("./location");
const actions_1 = require("./actions");
exports.createRoutingMiddleware = (config, history) => {
    return (store) => {
        // todo: when to unsubscribe?
        history.listen((location) => {
            const parsed = location_1.parseLocation(config, location);
            store.dispatch(actions_1.changeLocation(parsed));
        });
        return (next) => {
            return (action) => {
                const result = next(action);
                if (action.type === actions_1.HISTORY_METHOD_CALLED) {
                    const { url } = action;
                    history.push(url); // todo: поддержать остальные методы, кроме push
                }
                return result;
            };
        };
    };
};
